# -*- coding: utf-8 -*-
# Generated by Django 1.10.1 on 2016-10-11 10:18
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Achievement',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(default='', max_length=100)),
                ('identifier_string', models.CharField(blank=True, default='', max_length=10)),
                ('description', models.TextField(blank=True, default='')),
                ('image_url', models.URLField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Assignment',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_public', models.BooleanField(default=False)),
                ('difficulty_level', models.IntegerField()),
                ('resource_url', models.URLField(blank=True, null=True)),
                ('title', models.CharField(max_length=100)),
                ('assignment_text', models.TextField(blank=True, default='')),
                ('hint_text', models.TextField(blank=True, default='')),
                ('code_body', models.TextField(blank=True, default='')),
                ('solution', models.TextField(blank=True, default='')),
            ],
        ),
        migrations.CreateModel(
            name='AssignmentType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('type_name', models.CharField(default='', max_length=20)),
            ],
        ),
        migrations.CreateModel(
            name='ScoreTypeTracker',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('score', models.IntegerField(default=0)),
                ('current_streak', models.IntegerField(default=0)),
                ('maximum_streak', models.IntegerField(default=0)),
                ('assignment_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='api.AssignmentType')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='SkillTypeLevel',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('skill_level', models.IntegerField(default=1)),
                ('this_level_correct', models.IntegerField(blank=True, default=0)),
                ('this_level_wrong', models.IntegerField(blank=True, default=0)),
                ('assignment_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='api.AssignmentType')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='StreakTracker',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('streak', models.IntegerField(default=0)),
                ('maximum_streak', models.IntegerField(default=0)),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Student',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('aggregated_score', models.IntegerField(default=0)),
                ('attempted_assignments', models.IntegerField(default=0)),
                ('achievements', models.ManyToManyField(blank=True, to='api.Achievement')),
                ('assignments_solved', models.ManyToManyField(blank=True, to='api.Assignment')),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.AddField(
            model_name='assignment',
            name='assignment_type',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='api.AssignmentType'),
        ),
    ]
